//Date: 2020/2/7
var File = Java.type("java.io.File");
var FileReader = Java.type("java.io.FileReader");
var BufferedReader = Java.type("java.io.BufferedReader");
var FileWriter = Java.type("java.io.FileWriter");
var BufferedWriter = Java.type("java.io.BufferedWriter");
var Random = Java.type("java.util.Random");

//Math Utils
function getRandomInt(min, max) {//int
    //get a random integer in[min,max]
    return min <= max ? (new Random()).nextInt(max - min + 1) + min : 0;
}

function logarithm(a, b) {
    return Math.log(b) / Math.log(a);
}

function isFloat(n) {//boolean
    return n === +n && n !== (n|0);
}
  
function isInteger(n) {//boolean
    return n === +n && n === (n|0);
}

//File Utils
function readFile(filePath) {
    try {
        var file = new File(filePath);
        var reader = new BufferedReader(new FileReader(file));
        var content = [];
        var line;

        while ((line = reader.readLine()) !== null) {
            content.push(line);
        }

        return content;
    } catch (err) {
        log("§5§l[§d§lKirisame§5§l]§r", "Unable to open file!", true);

        throw err;
    }
}

function writeFile(path, string) {
    try {
        writer = new BufferedWriter(new FileWriter(path));
        writer.write(string);

        writer.close();
    } catch (err) {}
}

//Minecraft Utils
//Render Utils
function drawString(string, x, y, color, withShadow) {//void; string:str x:float y:float color:intHex/str withShadow:bool 
    withShadow ? mc.fontRendererObj.drawStringWithShadow(string, x - mc.fontRendererObj.getStringWidth(string) / 2, y, color) : mc.fontRendererObj.drawString(string, x - mc.fontRendererObj.getStringWidth(string) / 2, y, color);
}
//Chat Utils
function log(message, isError) {//void
    chat.print("§5§l[§d§lSakura§5§l]§r" + (isError ? " §c" : " §7") + message);
}
//Movement Utils
function getMoveSpeed() {//float
    return Math.sqrt(mc.thePlayer.MotionX * mc.thePlayer.MotionX + mc.thePlayer.MotionZ * mc.thePlayer.MotionZ);
}

function tryMoving() {//boolean
    return mc.gameSettings.keyBindForward.isKeyDown() || mc.gameSettings.keyBindBack.isKeyDown() || mc.gameSettings.keyBindLeft.isKeyDown() || mc.gameSettings.keyBindRight.isKeyDown();
}

function isMoving() {//boolean
    return mc.thePlayer != null && (mc.thePlayer.movementInput.moveForward != 0 || mc.thePlayer.movementInput.moveStrafe != 0);
}

function hasMotion() {//boolean
    return mc.thePlayer.motionX != 0 && mc.thePlayer.motionZ != 0 && mc.thePlayer.motionY != 0;
}

function getDirection() {//double
    var rotationYaw = mc.thePlayer.moveForward < 0 ? mc.thePlayer.rotationYaw + 180 : mc.thePlayer.rotationYaw;
    var forward = mc.thePlayer.moveForward == 0 ? 1 : (mc.thePlayer.moveForward < 0 ? -0.5 : 0.5);
    if (mc.thePlayer.moveStrafing > 0) rotationYaw -= 90 * forward;
    if (mc.thePlayer.moveStrafing < 0) rotationYaw += 90 * forward;
    return rotationYaw * Math.PI / 180;
}

function strafe(speed) {//void speed:float
    if(!isMoving()) return;
    var yaw = getDirection();
    mc.thePlayer.motionX = -Math.sin(yaw) * speed;
    mc.thePlayer.motionZ = Math.cos(yaw) * speed;
}

function forward(length) {//void length:double/float
    var yaw = mc.thePlayer.rotationYaw * Math.PI / 180;
    mc.thePlayer.setPosition(mc.thePlayer.posX + (-Math.sin(yaw) * length), mc.thePlayer.posY, mc.thePlayer.posZ + (Math.cos(yaw) * length));
}

//Array Utils
Array.prototype.remove = function(val) {//Array(this)
    var index = this.indexOf(val);
    if (index > -1) {
    this.splice(index, 1);
    }
};

//String Utils
function toTimeStr(second) {//str second:int
    /*用于将秒(int类型)转化为日时分秒格式的字符串*/
    var s1, m1, h1, d1;
    var s = second % 60;
    var m = Math.floor(second / 60) % 60;
    var h = Math.floor(second / 3600) % 24;
    var d = Math.floor(second / 86400);
    s1 = s == 0 ? "" : s.toString() + " Sec ";
    m1 = m == 0 ? "" : m.toString() + " Min ";
    h1 = h == 0 ? "" : h.toString() + " Hour ";
    d1 = d == 0 ? "" : d.toString() + " Day ";
    return (d1 + h1 + m1 + s1).trim();
}

function randomString(length) {//str
    var text = "";
    var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

    for (var i = 0; i < length; i++) {
        text += possible.charAt((new Random()).nextInt(possible.length));
    }

    return text;
}

